<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE configuration>

<configuration scan="true" scanPeriod="30 seconds">

    <!-- Includes -->
    <include resource="org/springframework/boot/logging/logback/defaults.xml"/>

    <!-- Common variables -->
    <springProperty scope="context" name="applicationName" source="spring.application.name"/>

    <!-- Console variables -->
    <springProperty scope="context" name="loggingConsoleEnabled" source="logging.console.enabled" defaultValue="true"/>
    <springProperty scope="context" name="loggingConsoleLevel" source="logging.console.level"/>

    <!-- File variables -->
    <springProperty scope="context" name="loggingFileEnabled" source="logging.file.enabled" defaultValue="false"/>
    <springProperty scope="context" name="loggingFile" source="logging.file" defaultValue="./log/${applicationName}.log"/>

    <!-- Appenders  -->

    <if condition='property("loggingFileEnabled").equals("true")'>
        <then>
            <include resource="org/springframework/boot/logging/logback/file-appender.xml"/>
        </then>
    </if>

    <!-- Custom Appenders -->
    <appender name="CONSOLE" class="ch.qos.logback.core.ConsoleAppender">
        <encoder>
            <pattern>${CONSOLE_LOG_PATTERN}</pattern>
        </encoder>
        <if condition='isDefined("loggingConsoleLevel")'>
            <then>
                <filter class="ch.qos.logback.classic.filter.ThresholdFilter">
                    <level>${loggingConsoleLevel}</level>
                </filter>
            </then>
        </if>
    </appender>

    <!-- Log levels -->

    <root level="info">
        <if condition='property("loggingConsoleEnabled").equals("true")'>
            <then>
                <appender-ref ref="CONSOLE"/>
            </then>
        </if>
        <if condition='property("loggingFileEnabled").equals("true")'>
            <then>
                <appender-ref ref="FILE"/>
            </then>
        </if>
    </root>

</configuration>
